<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Tables"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.0 / September 2013

*/

if (!defined('CPO')) exit;
$translator->addTranslation('navigation',CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['Tabellen'] = array(
	'directory'     => $moduleDirectory,
    'install'       => 'function: Tabellen_install',
    'activate'      => 'function: Tabellen_activate',
    'deactivate'    => 'function: Tabellen_deactivate',
    'uninstall'     => 'function: Tabellen_uninstall',
    'manage'        => 'function: Tabellen_manage',
// rights settings -------------------------------------------------------------------------------------
	'rights'=>array('1'=>'111'),
	'clickable_headers'		=> 'yes',
	'default_number_format' => '%01.2f',
	'owner'		            => $cpoSystem['owner'],
	'lkey'		            => '',
	'mod_id'	            => 5,
	'csv'                   => 'semicolon',
	'quotes'                => 'quote',
	'ext'                   => 'csv',
    'helptoc'	            => array(
        'bersicht' 
            => 'http://manual.conpresso4.de/tables/index.htm',
        '1. Was macht das Modul "Tabellen"?' 
            => 'http://manual.conpresso4.de/tables/features.htm',
        '2. Installation' 
            => 'http://manual.conpresso4.de/tables/setup.htm',
        '3. Einstellungen' 
            => 'http://manual.conpresso4.de/tables/settings.htm',
        '4.Anwendung' 
            => 'http://manual.conpresso4.de/tables/application.htm'
    ),

	
	
	'value'=>''

);

// Hier kommen die Basis-Funktionen ***************************************************************

function log_tables()
{
	global $cpoSystem;
	@mail('kontakt@conpresso4.de','Das Modul Tabellen 4.0 wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
}

function Tabellen_install()
{
	global $dbPrefix, $db;
	$tablesdb = new DB;
	$tablesdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('tables', '".serialize(array("installed"=>time()))."', '') ");
	include (CPO_BASEDIR.$GLOBALS['modules']['Tabellen']['directory'].'/includes/setup.inc.php');
    log_tables();
}

function Tabellen_activate()
{
	// Navigation reloaden in frame "cpo_navigation"
	$reload_navigation = "<script type=\"text/javascript\">";
	$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
	$reload_navigation .= "</script>";

    $GLOBALS['message'][] = __('The tables-module got activated.').$reload_navigation;
}

function Tabellen_deactivate()
{
	$reload_navigation = "<script type=\"text/javascript\">";
	$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
	$reload_navigation .= "</script>";

    $GLOBALS['message'][] = __('The tables-module got deactivated.').$reload_navigation;
}

function Tabellen_uninstall()
{
	global $dbPrefix, $db, $translator;
//	$query = "DROP TABLE IF EXISTS ".$dbPrefix."_mod_tables";
//	$db->query($query);
	$GLOBALS['message'][] .= sprintf(__('The table module was removed from the ConPresso-system. To finally uninstall the module, please remove the module directory <em>%s</em>.'),$GLOBALS['modules']['Tabellen']['directory']);
	$GLOBALS['message'][] .= sprintf(__('The module tables have been kept! Click <a href="%s">here to delete these tables</a> irreversibly.'),'modules.php?purge=Tabellen');
}

function Tabellen_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	printIcon(
		BASE_ABS.$GLOBALS['modules']['Tabellen']['directory'].'/edit.php?list=options', 
		BASE_ABS.'_skin/conpresso/pic_settings.gif', 
		(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('options') : __('not available'),
		array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
	);
	printIcon(
		BASE_ABS.$GLOBALS['modules']['Tabellen']['directory'].'/edit.php?list=rights',
		BASE_ABS.'_skin/conpresso/pic_rights.gif', 
		(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('rights') : __('not available'),
		array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
	);
}

function Tabellen_navigation()
{
	global $activeModules;
	$GLOBALS['navigation']['Modules'][] = array(
		'caption'=>__('Tables'),
		'title'=>__('work on tables'),
		'url'=>BASE_URL.$activeModules['Tabellen']['directory'].'/edit.php'
	);
}

$tablesdb = new DB;
$tablesdb->query('SELECT options FROM '.CPO_OPTION.' '
		  ."WHERE type='tables' ORDER BY id ASC LIMIT 0,1");
while ($tablesdb->next_record()) {
	$options = $tablesdb->v('options');
	$tablesOpt = unserialize($options);
	if (!is_array($tablesOpt)) break;
	foreach ($tablesOpt as $key=>$v) {
		$activeModules['Tabellen'][$key] = $v;
	}
}
if (	license($activeModules['Tabellen']['lkey'],$activeModules['Tabellen']['mod_id']) != 1 &&
		license($activeModules['Tabellen']['lkey'],$activeModules['Tabellen']['mod_id']) != 2 &&
		license($activeModules['Tabellen']['lkey'],$activeModules['Tabellen']['mod_id']) != 3 &&
		$activeModules['Tabellen']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/producer.inc.php')
	) 
	{
	if (@file_exists(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/producer.inc.php')) include(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$tmbreak = true;
}

$id = $_SESSION['SID_user']['id'];
$rights = $activeModules['Tabellen']['rights'][$id];
$permission_to_see = $rights{0};
if ($_SESSION['SID_user']['admin']>=ROLE_EDITOR && $permission_to_see == 1)  
	$hdlr_navigation[] = 'function: Tabellen_navigation';

$hdlr_parser_content['table']  = array('include: '.CPO_BASEDIR.$GLOBALS['modules']['Tabellen']['directory'].'/includes/parser_c_table.inc.php');
$hdlr_parser_replacement['table']  = array('include: '.CPO_BASEDIR.$GLOBALS['modules']['Tabellen']['directory'].'/includes/parser_r_table.inc.php');

if ($_GET['purge']=='Tabellen') {
	$query = "DROP TABLE IF EXISTS ".$dbPrefix."_mod_tables";
	$db->query($query);
	$query = "DROP TABLE IF EXISTS ".$dbPrefix."_mod_table_presets";
	$db->query($query);
    $message[] = __('The module tables have been deleted!');
}
?>
