<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Tables"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.0 / September 2013

*/

require_once(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/inc_table_functions.inc.php');

// ####################################################################################################
// Moduleinstellungen speichern
if (isset($_POST['go']) && isset($_POST['list'])) {
	save_table_modulesettings('cpoTablesNew', 'Tabellen');
}

//print_r($_POST);
// ####################################################################################################
// ******* handling the presets ***************************************
if ($_POST['action'] == 'save_preset') {
	$query = "SELECT table_design FROM ".$dbPrefix."_mod_tables WHERE id=".$_POST['fields']; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();
	$table_design = $db->v('table_design');
	$query = "INSERT INTO ".$dbPrefix."_mod_table_presets (id, name, settings) VALUES ('', '".addslashes($_POST['cpoTablesCustom'])."', '".addslashes($table_design)."')"; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = sprintf(__('Custom preset <i>%s</i> was saved!'), addslashes($_POST['cpoTablesCustom']));
}
if ($_GET['preset'] == 'delete') {
    $db = new DB;
	$query = "SELECT name FROM ".$dbPrefix."_mod_table_presets WHERE id=".$_GET['id']; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query);
    $db->next_record();
    $name = $db->v('name'); 
	$query = "DELETE FROM ".$dbPrefix."_mod_table_presets WHERE id=".$_GET['id']; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query); 
    $message[] = sprintf(__('The custom preset <em>%s</em> was successfully deleted!'),$name);
}
if ($_GET['preset'] == 'load') {
	$query = "SELECT settings FROM ".$dbPrefix."_mod_table_presets WHERE id=".$_GET['id']; 
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
    $db->next_record();
	$settings = $db->v('settings');
	$query = sprintf(
             "UPDATE ".$dbPrefix."_mod_tables SET "
			. "table_design = '%s' "
			. "WHERE id = ".$_GET['fields'], 
			addslashes($settings)
			);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
    $message[] = __('The custom preset was successfully loaded as new template!');
}

// defaults aus template laden
if (isset($_GET['default'])) {
	if (file_exists("templates/" . $_GET['default'] . "/defaults.inc.php"))  {
		include ("templates/" . $_GET['default'] . "/defaults.inc.php");
		$query = sprintf(
				 "UPDATE ".$dbPrefix."_mod_tables SET "
				. "table_design = '%s' "
				. "WHERE id = ".$_GET['fields'], 
				addslashes(serialize($default_design))
				);
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		$message[] = sprintf(__('Template <i>%s</i> is loaded!'), $_GET['default']);
	} else {
		$message[] = "Template not found!";
	}
}


// Rechteeinstellungen speichern *********************************************************************
if(isset($_GET['tables_user_id'])) {
	$tables_user_id = $_GET['tables_user_id'];
	$tables_set_rights = $_GET['set'];
	$activeModules['Tabellen']['rights'][$tables_user_id] = $tables_set_rights;

    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = 'Tabellen'", 
            addslashes(serialize($activeModules['Tabellen']))
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
}

// Tabelle kopieren ***********************************************************************************
if (isset($_GET['copy']))  {
	// Tabelle lesen
	$query = "SELECT * FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['copy']."";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db->query($query);
    $db->next_record();
	// Tabelle schreiben
	$query = "INSERT INTO ".$dbPrefix."_mod_tables (id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username) VALUES ('', '".__('Copy of ').$db->v('name')."', '".$db->v('description')."', '".$db->v('max_sort')."', '".$db->v('multiple_rows')."', '".addslashes($db->v('table_design'))."', '".addslashes($db->v('table_fields'))."', '".addslashes($db->v('table_values'))."', '".$_SESSION['SID_user']['name']."')";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db->query($query);
    $message[] = sprintf(__("The table <em>%s</em> was copied as <em>%s</em>."),$db->v('name'),__('Copy of ').$db->v('name'));
}

// Datei importieren **********************************************************************************
if (isset($_POST['import']))  {
    unset ($_GET); // to avoid conflicts with former url-parameters
	include(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/inc_default_table.inc.php');
	//$readable_format = TRUE;
	//echo $_FILES['upload_table']['type'];

    if (isset($_POST['edit']))  {
        $query = "SELECT id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username FROM ".$dbPrefix."_mod_tables WHERE id = ".$_REQUEST['edit'];
        DEBUG(2, $query, __FILE__, __LINE__);  
        $db = new DB;
        $db->query($query);
        if ($db->num_rows()>0)  {
            $db->next_record();
            $edit_table_name = $db->v('name');
            $edit_table_description = $db->v('description');
            $edit_table_max_sort = $db->v('max_sort');
            $edit_table_multiple_rows = $db->v('multiple_rows');
            $edit_table_table_design = $db->v('table_design');
            $edit_table_username = $db->v('username');
            $edit_table_fields = unserialize($db->v('table_fields'));
            $edit_table_values = unserialize($db->v('table_values'));
        }
    }

    $possible_CSVs = array(
        'application/vnd.ms-excel',
        'text/plain'
    );
	if (in_array($_FILES['upload_table']['type'],$possible_CSVs))  {
		if ($_POST['csv']=='semicolon')	$explode = ";"; 
		if ($_POST['csv']=='colon')		$explode = ","; 
		if ($_POST['csv']=='tab')		$explode = "\t"; 
		$table_data = file($_FILES['upload_table']['tmp_name']);
		while(list($zeile_num, $zeile) = each($table_data))  {
			$zeile = explode($explode,str_replace('"','',trim($zeile)));
			if (is_array($zeile) && $zeile_num == 0)  {
				$table_fields[0] = $zeile;
				for ($i=0;$i<count($zeile);$i++)  {
					$table_fields[1][] = "Text";		// Felddatentyp
					$table_fields[2][] = "center";		// Ausrichtung Header
					$table_fields[3][] = 1;				// Kein Umbruch
					$table_fields[4][] = "left";		// Ausrichtung Felder
					$table_fields[5][] = 0;				// Kein Umbruch
					$table_fields[6][] = '';			// Zahlenformat
				}
			}
			if (is_array($zeile) && $zeile_num > 0)  {
				$table_values[] = $zeile;
			}
		}
        if (isset($_POST['edit']) && $_POST['mode']=='append')  {
            $table_values = array_merge($edit_table_values, $table_values);
        }
        // Tabelle schreiben
        if (isset($_POST['edit']))  {
            $query = "REPLACE INTO ".$dbPrefix."_mod_tables (id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username) VALUES ('".$_POST['edit']."', '".$edit_table_name."', '".$edit_table_description."', ".$edit_table_max_sort.", '".$edit_table_multiple_rows."','" . $edit_table_table_design . "', '" . addslashes(serialize($edit_table_fields)) . "', '" . addslashes(serialize($table_values)) . "', '" . $edit_table_username . "')";
            $db->query($query);
            $message[] = sprintf(__('The data from <em>%s</em> was importet to the table <em>%s</em>.'),$_FILES['upload_table']['name'],$edit_table_name);
        } else {
            $query = "INSERT INTO ".$dbPrefix."_mod_tables (id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username) VALUES ('', '".__('imported table')."', '".__('CSV-import from: ').$_FILES['upload_table']['name']."', 3, 'single','" . addslashes(serialize($demo_design)) . "', '" . addslashes(serialize($table_fields)) . "', '" . addslashes(serialize($table_values)) . "', '" . $_SESSION['SID_user']['name'] . "')";
            $db->query($query);
            $message[] = sprintf(__('The data from <em>%s</em> was importet and saved as <em>%s</em>.'),$_FILES['upload_table']['name'],__('imported table'));
        }
	} elseif ($_FILES['upload_table']['type'] == "application/octet-stream" && function_exists('dbase_open'))  {
		$tabledb = dbase_open($_FILES['upload_table']['tmp_name'],0);
		// throw record 1 into associative array key=>value
		$res = dbase_get_record_with_names($tabledb, 1);		
		// retrieves all the keys from previous array, which are field names
		$table_fields[0] = array_keys($res);
		for ($i=0;$i<count($table_fields[0]);$i++)  {
			$table_fields[1][] = "Text";		// Felddatentyp
			$table_fields[2][] = "center";		// Ausrichtung Header
			$table_fields[3][] = 1;				// Kein Umbruch
			$table_fields[4][] = "left";		// Ausrichtung Felder
			$table_fields[5][] = 0;				// Kein Umbruch
			$table_fields[6][] = '';			// Zahlenformat
		}
		for ($nr=1; $nr<=dbase_numrecords($tabledb); $nr++)  {
			$zeile = dbase_get_record($tabledb, $nr);
			$table_values[] = $zeile;
		}
		// Tabelle schreiben
		$query = "INSERT INTO ".$dbPrefix."_mod_tables (id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username) VALUES ('', '".__('imported table')."', '".__('dBase-import from: ').$_FILES['upload_table']['name']."', 3, 'single','" . addslashes(serialize($demo_design)) . "', '" . iconv("CP437", "ISO-8859-1", addslashes(serialize($table_fields))) . "', '" . iconv("CP437", "ISO-8859-1",  addslashes(serialize($table_values))) . "', '" . $_SESSION['SID_user']['name'] . "')";
		$db->query($query);
		$message[] = sprintf(__('The data from <em>%s</em> was importet and saved as <em>%s</em>.'),$_FILES['upload_table']['name'],__('imported table'));
	} elseif ($_FILES['upload_table']['type'] == "application/octet-stream" && !function_exists('dbase_open'))  {
        $table = read_dbf($_FILES['upload_table']['tmp_name']);
		$table_fields[0] = array_keys($table);
		for ($i=0;$i<count($table_fields[0]);$i++)  {
			$table_fields[1][] = "Text";		// Felddatentyp
			$table_fields[2][] = "center";		// Ausrichtung Header
			$table_fields[3][] = 1;				// Kein Umbruch
			$table_fields[4][] = "left";		// Ausrichtung Felder
			$table_fields[5][] = 0;				// Kein Umbruch
			$table_fields[6][] = '';			// Zahlenformat
		}
		for ($col=0; $col<count($table); $col++)  {
		    for ($nr=0; $nr<count($table[$table_fields[0][0]]); $nr++)  {
                $val = trim($table[$table_fields[0][$col]][$nr]);
                $val = (is_numeric($val)) ? (float)$val : $val;
			    $table_values[$nr][$col] = $val;
            }
		}
		// Tabelle schreiben
		$query = "INSERT INTO ".$dbPrefix."_mod_tables (id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username) VALUES ('', '".__('imported table')."', '".__('dBase-import from: ').$_FILES['upload_table']['name']."', 3, 'single','" . addslashes(serialize($demo_design)) . "', '" . iconv("CP437", "ISO-8859-1", addslashes(serialize($table_fields))) . "', '" . iconv("CP437", "ISO-8859-1",  addslashes(serialize($table_values))) . "', '" . $_SESSION['SID_user']['name'] . "')";
		$db->query($query);
		$message[] = sprintf(__('The data from <em>%s</em> was importet and saved as <em>%s</em>.'),$_FILES['upload_table']['name'],__('imported table'));
	} else {
		$message[] = __('No readable file format!');
		$readable_format = FALSE;
	}
}

// Zeile lschen **************************************************************************************
if (isset($_GET['kill_row']))  {
	$query = "SELECT table_values FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['edit'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_values = unserialize($db->v('table_values'));
		$z = 0;
		for ($f=0;$f<count($table_values);$f++)  {
			if ($f != $_GET['kill_row'] && is_array($table_values[$f]))  $new_table_values[] = $table_values[$f];
		}
		$_POST['go'] = TRUE;
		$_POST['edit'] = $_GET['edit'];
		unset ($_POST['new_table_values']);
		$_POST['new_table_values'] = $new_table_values;
	}
}

// Feld lschen **************************************************************************************
if (isset($_GET['kill_field']) && isset($_GET['fields']))  {
	$query = "SELECT table_fields FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['fields'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_fields = unserialize($db->v('table_fields'));
		for ($f=0;$f<count($table_fields[0]);$f++)  {
			if ($f != $_GET['kill_field'])  {
				$new_table_fields[0][] = $table_fields[0][$f];
				$new_table_fields[1][] = $table_fields[1][$f];
				$new_table_fields[2][] = $table_fields[2][$f];
				$new_table_fields[3][] = $table_fields[3][$f];
				$new_table_fields[4][] = $table_fields[4][$f];
				$new_table_fields[5][] = $table_fields[5][$f];
				$new_table_fields[6][] = $table_fields[6][$f];
				$new_table_fields[7][] = $table_fields[7][$f];
			}
		}
		$_POST['savefields'] = TRUE;
		$_POST['fields'] = $_GET['fields'];
		unset ($_POST['new_table_fields']);
		$_POST['new_table_fields'] = $new_table_fields;
	}
}

// Spalte verschieben **************************************************************************************
if ((isset($_GET['right']) || isset($_GET['left'])) && (isset($_GET['edit']) || isset($_GET['fields'])))  {
	if (isset($_GET['fields']) && !isset($_GET['edit']))  $_GET['edit'] = $_GET['fields'];
	$query = "SELECT table_fields, table_values FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['edit'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_fields = unserialize($db->v('table_fields'));
		for ($f=0;$f<count($table_fields);$f++)  {
			if (isset($_GET['right'])) $new_table_fields[$f] = switchArrayValues($table_fields[$f],$_GET['right'],'right');
			if (isset($_GET['left'])) $new_table_fields[$f] = switchArrayValues($table_fields[$f],$_GET['left'],'left');
		}
		$table_values = unserialize($db->v('table_values'));
		for ($v=0;$v<count($table_values);$v++)  {
			if (isset($_GET['right'])) $new_table_values[$v] = switchArrayValues($table_values[$v],$_GET['right'],'right');
			if (isset($_GET['left'])) $new_table_values[$v] = switchArrayValues($table_values[$v],$_GET['left'],'left');
		}
		$_POST['savefields'] = TRUE;
		$_POST['fields'] = $_GET['edit'];
		$_POST['new_table_fields'] = $new_table_fields;
		$_POST['go'] = TRUE;
		$_POST['edit'] = $_GET['edit'];
		$_POST['new_table_values'] = $new_table_values;
	}
}

// Zeile verschieben **************************************************************************************
if ( isset($_GET['sort']) && isset($_GET['order']) && isset($_GET['edit']))  {

    // $table_values = SortArray($table_values,$_GET['tbl_sort'],$_GET['tbl_order']);

	$query = "SELECT table_fields, table_values FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['edit'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_fields = unserialize($db->v('table_fields'));
		$table_values = unserialize($db->v('table_values'));
        $table_values = SortArray($table_values,$_GET['sort'],$_GET['order']);
		$_POST['savefields'] = TRUE;
		//$_POST['fields'] = $_GET['edit'];
		//$_POST['new_table_fields'] = $table_fields;
		$_POST['go'] = TRUE;
		$_POST['edit'] = $_GET['edit'];
		$_POST['new_table_values'] = $table_values;
	}
}

// Zeile hinzufgen **************************************************************************************
if (isset($_POST['addrow']) && isset($_POST['edit']))  {
	for ($i=0;$i<count($_POST['new_table_fields']);$i++)  {
		$neu[] = __('new');
	}
	$_POST['new_table_values'][count($_POST['new_table_values'])] = $neu;
	$_POST['go'] = TRUE;
	//$_POST['edit'] = $_POST['edit'];
}
// Feld hinzufgen **************************************************************************************
if (isset($_POST['addfield']) && isset($_POST['fields']))  {
	$query = "SELECT table_fields FROM ".$dbPrefix."_mod_tables WHERE id = ".$_POST['fields'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_fields = unserialize($db->v('table_fields'));
		$table_fields[0][] = "Feldname";
		$table_fields[1][] = "Text";
		$table_fields[2][] = "center";
		$table_fields[3][] = 0;
		$table_fields[4][] = "left";
		$table_fields[5][] = 0;
		$table_fields[6][] = "";
		$table_fields[7][] = "none";
	$query = sprintf(
		 "UPDATE ".$dbPrefix."_mod_tables SET "
		. "table_fields = '%s' "
		. "WHERE id = ".$_POST['fields'], 
		addslashes(serialize($table_fields))
		);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
	}
}

// Tabelle speichern **************************************************************************************
if (isset($_POST['go']) && isset($_POST['edit'])) {
	
    $query = "SELECT table_fields FROM ".$dbPrefix."_mod_tables WHERE id = ".$_POST['edit'];
	DEBUG(2, $query, __FILE__, __LINE__);  
	$db = new DB;
	$db->query($query);
	if ($db->num_rows()>0)  {
		$db->next_record();
		$table_fields = unserialize($db->v('table_fields'));
		for ($f=0;$f<count($table_fields);$f++)  {
			if ($f == 0 && isset($_POST['new_table_fields']))   {
				$alter_table_fields[0] = $_POST['new_table_fields'];
			}  else  {
				$alter_table_fields[] = $table_fields[$f];
			}
		}
	}

	$table_values = $_POST['new_table_values'];
	if (!isset($_GET['kill_row']) && !isset($_GET['left']) && !isset($_GET['right']))  {	// keine Checks beim Lschen einer Zeile oder Verschieben von Spalten!
		$table_values = check4numbers($alter_table_fields, $table_values);
		$table_values = check4times($alter_table_fields, $table_values);
		$table_values = check4dates($alter_table_fields, $table_values);
	}
	$query = sprintf(
             "UPDATE ".$dbPrefix."_mod_tables SET table_values = '%s', "
			. "table_fields = '%s' "
			. "WHERE id = ".$_POST['edit'], 
            addslashes(serialize($table_values)), 
			addslashes(serialize($alter_table_fields))
			);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

	if (isset($_POST['savetable']))  $message[] = __('Table was saved!');
    
}

// Felddefinition speichern **************************************************************************************
if (isset($_POST['savefields']) && isset($_POST['fields'])) {
	$query = sprintf(
             "UPDATE ".$dbPrefix."_mod_tables SET "
			. "table_fields = '%s' "
			. "WHERE id = ".$_POST['fields'], 
			addslashes(serialize($_POST['new_table_fields']))
			);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

	if (isset($_POST['savefields']) && !isset($_GET['kill_field']))  $message[] = __('Field-settings were saved!');
}

// Basiswerte speichern **************************************************************************************
if (isset($_POST['savebasic']) && isset($_POST['fields'])) {
	$query = sprintf(
             "UPDATE ".$dbPrefix."_mod_tables SET "
			. "name = '%s', description = '%s', max_sort = %s, multiple_rows = '%s' "
			. "WHERE id = ".$_POST['fields'], 
			addslashes($_POST['new_name']), 
			addslashes($_POST['new_description']), 
			$_POST['new_max_sort'], 
			$_POST['new_multiple_rows'] 
			);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
	if (isset($_POST['savebasic']))  $message[] = __('Basic values were saved!');
}

// Template speichern **************************************************************************************
if (isset($_POST['savetemplate']) && isset($_POST['fields'])) {
	$query = sprintf(
             "UPDATE ".$dbPrefix."_mod_tables SET "
			. "table_design = '%s' "
			. "WHERE id = ".$_POST['fields'], 
			addslashes(serialize($_POST['new_table_design']))
			);
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 
	if (isset($_POST['savetemplate']))  $message[] = __('Template was saved!');
}

// Tabelle lschen **************************************************************************************
if (isset($_GET['delete'])) {
    $db = new DB;
	$query = "SELECT * FROM ".$dbPrefix."_mod_tables WHERE id = ".$_GET['delete']."";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db->query($query);
    $db->next_record();
    $name = $db->v('name');
	$query = "DELETE FROM " . $dbPrefix . "_mod_tables WHERE id = ".$_GET['delete'];
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query); 
    $message[] = sprintf(__('The table was <em>%s</em> successfully deleted!'),  $name );
}


?>