<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Tables"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.0 / September 2013

*/

printPageHeader(
    __('Tables'),
    __('This is the administration of the table-options and settings.'),
    'http://manual.conpresso4.de/tables/settings.htm',
    true,
    'modules'
);

include('includes/actions.inc.php');
require(CPO_BASEDIR."_include/message.php");

// ******** GENERAL SETTINGS ***************
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
		echo '<input type="hidden" name="go" value="1">';
		echo '<input type="hidden" name="list" value="options">';
 
		include(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/license.inc.php');

if (!$tmbreak)  {
    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';

    echo '<th colspan="2"><span>'.__('Table display settings').'</span></th>';

    echo '</tr></thead><tbody>';
    // }}}

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Clickable table headers:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoTablesNew[clickable_headers]" size="1">';
        $selyes = ($activeModules['Tabellen']['clickable_headers']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['Tabellen']['clickable_headers']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';
    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Default number format:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text" name="cpoTablesNew[default_number_format]" value="'.htmlspecialchars($activeModules['Tabellen']['default_number_format'], ENT_COMPAT, 'ISO-8859-15').'" maxlength="255">';
        echo '</select>';
        echo '</td>';
    echo '</tr>';
    if (version_compare($CPO['version'], '4.1.0') >= 0) {
        echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Page-Template:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<select name="cpoTablesNew[pagetemplate_index]" size="1">';
            echo '<option value="0"'
                .($activeModules['Tabellen']['pagetemplate_index']==0 ? ' selected' : '')
                .'>--- '.___('Use header and footer files').' ---</option>';
            $query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
                    .'ORDER BY name';
            $db->query($query);
            $_pagetemplates = array();
            while ($db->next_record()) {
                $_pagetemplates[$db->v('id')] = $db->v('name');
            }
            foreach ($_pagetemplates as $k=>$v) {
                echo '<option value="'.htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15').'"'
                    .($activeModules['Tabellen']['pagetemplate_index']==$k ? ' selected' : '')
                    .'>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</option>';
            }
            echo '</select>';
            echo '</td>';
        echo '</tr>';
    }

    
    echo '<tr>';
        echo '<td class="leftrow">';
        echo '&nbsp;';
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
        echo '</td>';
    echo '</tr>';
    echo '</tbody></table>';

    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';

    echo '<th colspan="2"><span>'.__('CSV export settings').'</span></th>';

    echo '</tr></thead><tbody>';
    // }}}

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('CSV character:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoTablesNew[csv]">';
        if ($activeModules['Tabellen']['csv']=='semicolon')	$semicolon_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['csv']=='colon')		$colon_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['csv']=='tab')		$tab_selected = ' selected="selected"'; 
        echo '<option value="semicolon" ' .	$semicolon_selected .	'>' . __('Semicolon') .	'</option>';
        echo '<option value="colon" ' .		$colon_selected .		'>' . __('Colon') .		'</option>';
        echo '<option value="tab" ' .		$tab_selected .			'>' . __('Tab') .		'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';
    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Text quoting:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoTablesNew[quotes]">';
        if ($activeModules['Tabellen']['quotes']=='quote')		$quote_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['quotes']=='apostr')		$apostr_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['quotes']=='none')		$none_selected = ' selected="selected"'; 
        echo '<option value="quote" ' .		$quote_selected .	'>' . __('Quotes') .	'</option>';
        echo '<option value="apostr" ' .	$apostr_selected .	'>' . __('Apostrophe') .'</option>';
        echo '<option value="none" ' .		$none_selected .	'>' . __('none') .		'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';
    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('File extension:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoTablesNew[ext]">';
        if ($activeModules['Tabellen']['ext']=='txt')		$txt_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['ext']=='csv')		$csv_selected = ' selected="selected"'; 
        if ($activeModules['Tabellen']['ext']=='dat')		$dat_selected = ' selected="selected"'; 
        echo '<option value="txt" ' .	$txt_selected .	'>' . __('txt') .	'</option>';
        echo '<option value="csv" ' .	$csv_selected .	'>' . __('csv') .	'</option>';
        echo '<option value="dat" ' .	$dat_selected .	'>' . __('dat') .	'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    
    echo '<tr>';
        echo '<td class="leftrow">';
        echo '&nbsp;';
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
        echo '</td>';
    echo '</tr>';
    echo '</tbody></table>';
}

echo '</form>';



?>