<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Tables"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.0 / September 2013

*/

// Table-Rechte
$id = $_SESSION['SID_user']['id'];
$rights = $activeModules['Tabellen']['rights'][$id];
$permission_to_see = $rights{0};
$permission_edit = $rights{1};
$permission_supervise = $rights{2};

    printPageHeader(
        __('Tables'),
        __('In this view you can work on the existing tables or create new tables.'),
        'http://manual.conpresso4.de/tables/application.htm',
        true,
        'modules'
    );

include('includes/actions.inc.php');
require(CPO_BASEDIR."_include/message.php");

if (!$tmbreak)  {

    //Tabellen Liste
	$where = ($_SESSION['SID_user']['admin'] >= ROLE_SUPERUSER || $permission_to_see == 1) ? "" : " WHERE username = '" . $_SESSION['SID_user']['name'] . "'";
    $query = "SELECT id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values, username FROM ".$dbPrefix."_mod_tables" . $where . " ORDER BY name";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    if ($db->num_rows()>0){
		// table header {{{
        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';
        echo '<th style="width: 80%;"><span>'.__('Name').'</span></th>';
        echo '<th style="width: 15%;"><span>'.__('Format').'</span></th>';
        if ($permission_edit == 1)  echo '<th style="width: 5%;"><span>'.__('Action').'</span></th>';
		echo '</tr></thead><tbody>';

        while($db->next_record()):
			$id = $db->v("id");
			$name = $db->v("name");
			$description = $db->v("description");
			$max_sort = $db->v("max_sort");
			$username = $db->v("username");
			$multiple_rows = $db->v("multiple_rows");
			$table_fields = unserialize($db->v('table_fields'));
			$table_values = unserialize($db->v('table_values'));
			$cols = count($table_fields[0]);
			$rows = count($table_values);
			$username = $db->v("username");
			echo "<tr><td>";
			echo "<a href=\"index.php?show=".$name."\" target=\"_blank\">";
			echo $name . "</a><br>".__('Author').": " . $username . "<br>".__('Description').": " . $description . "";
			echo "</td><td>";
			echo $cols."&nbsp;".__('columns')."&nbsp;x&nbsp;".$rows."&nbsp;".__('rows');
			echo "<br>";
			echo $max_sort.__(' times sorting');
			//echo "<br>";
			//echo __('rows').": ".__($multiple_rows);
			echo "</td>";
			if ( $permission_edit == 1 )  {
				echo "<td>";
				if ( $username == $_SESSION['SID_user']['name'] || $permission_supervise == 1 || $_SESSION['SID_user']['admin'] >= ROLE_SUPERUSER)  {
					// Bearbeiten
						echo '<a href="'.BASE_REL.$activeModules['Tabellen']['directory'].'/edit.php?edit='.$id.'">';
						echo '<img src="'.SKIN_URL.'pic_edit.gif" class="pic_" alt="'.__('edit table').'" title="'.__('edit table').'" />'; 
						echo '</a>';
					// Felder
						echo '<a href="'.BASE_REL.$activeModules['Tabellen']['directory'].'/edit.php?fields='.$id.'">';
						echo '<img src="'.SKIN_URL.'pic_settings.gif" class="pic_" alt="'.__('define table').'" title="'.__('define table').'" />'; 
						echo '</a>';
					// Kopieren
						echo '<a href="'.BASE_REL.$activeModules['Tabellen']['directory'].'/edit.php?copy='.$id.'">';
						echo '<img src="'.SKIN_URL.'pic_copy.gif" class="pic_" alt="'.__('copy table').'" title="'.__('copy table').'" />'; 
						echo '</a>';
					// Lschen
						echo '<a href="'.BASE_REL.$activeModules['Tabellen']['directory'].'/edit.php?delete='.$id.'" onClick="return confirm(\''.__('Do you really want to delete this table and all the content?').'\')">';
						echo '<img src="'.SKIN_URL.'pic_del.gif" class="pic_" alt="'.__('delete table').'" title="'.__('delete table').'" />'; 
						echo '</a>';
				}
				echo "</td>";
			}
			echo "</tr>";
        endwhile;

		echo '</tbody></table>';


    } else {    
        $message[] = __('No tables founds!');
        require(CPO_BASEDIR."_include/message.php");     
    }

	if ($permission_edit == 1)  {
		echo '<form method="get" action="edit.php"><input type="hidden" name="table" value="new"><input type="submit" value="' . __('Click to create a new table') . '"></form><BR> <BR> <BR>';

?>

<form method="post" action="<?php echo $PHP_SELF; ?>" enctype="multipart/form-data">
<input type="hidden" name="import" value="1">
<table class="colored" style="width: 100%;">
	<thead>
		<tr>
			<th colspan="2"><span><?php echo __('Upload table file'); ?></span></th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td class="leftrow"><?php echo __('File to upload:'); ?> </td>
			<td class="rightrow"><input class="text inputwidth" type="file" name="upload_table"></td>
		</tr>
		<tr>
			<td><?php echo __('Field delimiter in csv files:'); ?></td>
			<td>
<?php
            echo '<select name="csv">';
			if ($activeModules['Tabellen']['csv']=='semicolon')	$semicolon_selected = ' selected="selected"'; 
			if ($activeModules['Tabellen']['csv']=='colon')		$colon_selected = ' selected="selected"'; 
			if ($activeModules['Tabellen']['csv']=='tab')		$tab_selected = ' selected="selected"'; 
			echo '<option value="semicolon" ' .	$semicolon_selected .	'>' . __('Semicolon') .	'</option>';
			echo '<option value="colon" ' .		$colon_selected .		'>' . __('Colon') .		'</option>';
			echo '<option value="tab" ' .		$tab_selected .			'>' . __('Tab') .		'</option>';
			echo '</select>';
?>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" value="<?php echo __('upload'); ?>"/></td>
		</tr>
	</tbody>
</table>
</form>

<?php

	}
}

?>