<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Tables"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.0 / September 2013

*/

if (!defined('CPO')) exit;

global $content, $db_titel, $dbPrefix, $activeModules, $db_nr, $rubric, $cpoRubric, $_GET;

require_once(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/inc_table_functions.inc.php');

// Parser-Arrays
	$content['Table (table)'] = array(
		'type'		=>'TABLE',
		'name'		=>'Table',
		'content'   =>''
	);
	$content['Sort (table)'] = array(
		'type'		=>'TABLE',
		'name'		=>'Sort',
		'content'   =>''
	);
	$content['Export (table)'] = array(
		'type'		=>'TABLE',
		'name'		=>'Export',
		'content'   =>''
	);


// Tabelle auslesen
	$query = "SELECT id, name, description, max_sort, multiple_rows, table_design, table_fields, table_values FROM ".$dbPrefix."_mod_tables WHERE name = '".$db_titel."'";
    DEBUG(2, $query, __FILE__, __LINE__);  
    $db = new DB;
    $db->query($query);
    if ($db->num_rows()>0)  {
		while($db->next_record()):
		$table_id = $db->v('id');
		$table_name = $db->v('name');
		$table_description = $db->v('description');
		$max_sort_fields = $db->v('max_sort');
		$table_multiple_rows = $db->v('multiple_rows');
		$table_design = unserialize($db->v('table_design'));
		$table_fields = unserialize($db->v('table_fields'));
		$table_values = unserialize($db->v('table_values'));
		// Sortierung
		if (isset($_GET['tbl_sort']) && isset($_GET['tbl_order']) && $_GET['tbl_id'] == $table_id) $table_values = SortArray($table_values,$_GET['tbl_sort'],$_GET['tbl_order']);
		// Multi-Sortierung
		if (isset($_GET['multisort']) && $_GET['tbl_id'] == $table_id)  {
			$multisort = explode("-",$_GET['multisort']);
			$table_values = SortArray($table_values,$multisort);
		}
		$spalten = count($table_fields[0]);
		$args = '';
		if (isset($rubric))  $args .= "&rubric=" . $rubric;
		if (isset($nr))  $args .= "&nr=" . $nr;

        $pre_table_string = (!isset($table_js)) ? '<script type="text/javascript" src="../mod_tables/mod_tables.js"></script>' : '';
        $table_js = true;

        include(CPO_BASEDIR.$activeModules['Tabellen']['directory'].'/includes/inc_create_table.inc.php');

		$content['Table (table)']['content'] .= $pre_table_string.'<div id="httptable'.$table_id.'">'.$table_string.'</div>';

	// Sortierfeld *********************************
		$sort_string = '';
		$multi_sort = explode("-",$_GET['multisort']);
		$sort_string .= '<script language="JavaScript" type="text/JavaScript">'."\n";
		$sort_string .= 'function createSortString'.$table_id.'() { '."\n";
		$sort_string .= "document.do_sort".$table_id.".multisort.value = '';\n";
		for ($s=0;$s<min($max_sort_fields, count($table_fields[0]));$s++)  {
			$sort_string .= "if (document.sort".$table_id.".sort_id".$s.".value != '') document.do_sort".$table_id.".multisort.value += document.sort".$table_id.".sort_id".$s.".value + '-' + document.sort".$table_id.".sort_order".$s.".value;\n";
			$sort_string .= "if (document.sort".$table_id.".sort_id".($s+1)." && document.sort".$table_id.".sort_id".($s+1).".value != '' && document.sort".$table_id.".sort_id".$s.".value != '') document.do_sort".$table_id.".multisort.value += '-';\n";
		}
		$sort_string .= 'var multisort = document.do_sort'.$table_id.'.multisort.value;'."\n";
		$sort_string .= 'sort_table('.$table_id.',0,0,multisort);'."\n";
		$sort_string .= '}'."\n";
		$sort_string .= '</script>'."\n";

		$sort_string .= '<table border="0"><form name="sort'.$table_id.'" action="' . $_PHPSELF . '" method="get"><tr><td>';
		for ($s=0;$s<min($max_sort_fields, count($table_fields[0]));$s++)  {
			$sort_string .= '<select name="sort_id'.$s.'">';
			$sort_string .= '<option value="">-- '.__('choose').' --</option>';
			for ($f=0;$f<count($table_fields[0]);$f++)  {
				$selected = '';
				if (isset($multisort[$s*2]) && $multisort[$s*2] == $f)  $selected =' selected="selected"';
				$sort_string .= '<option value="'.$f.'"'.$selected.'>'.$table_fields[0][$f].'</option>';
			}
			$sort_string .= '</select>';
			$sort_string .= '<select name="sort_order'.$s.'">';
			$selected_asc = '';
			$selected_desc = '';
			if (isset($multisort[$s*2+1]) && $multisort[$s*2+1] == "ASC")  $selected_asc =' selected="selected"';
			if (isset($multisort[$s*2+1]) && $multisort[$s*2+1] == "DESC")  $selected_desc =' selected="selected"';
			$sort_string .= '<option value="ASC"'.$selected_asc.'>'.__('ascending').'</option>';
			$sort_string .= '<option value="DESC"'.$selected_desc.'>'.__('descending').'</option>';
			$sort_string .= '</select><br>';
		}
		$sort_string .= '</td></tr></form><form name="do_sort'.$table_id.'" action="' . $_PHPSELF . '" method="get"><tr><td>';
		if (isset($_REQUEST['rubric']))  $sort_string .= '<input type="hidden" name="rubric" value="' . $_REQUEST['rubric'] . '">';
		if (isset($_REQUEST['nr']))	$sort_string .= '<input type="hidden" name="nr" value="' . $_REQUEST['nr'] . '">';
		if (isset($_REQUEST['show']))	$sort_string .= '<input type="hidden" name="nr" value="' . $_REQUEST['show'] . '">'; // the preview
		$sort_string .= '<input type="hidden" name="tbl_id" value="' . $table_id . '">';
		$sort_string .= '<input type="hidden" name="multisort" value="">';
        $sort_string .= $hidden_string;
		$sort_string .= '<input type="submit" value="' . __('sort table') . '" onClick="createSortString' . $table_id . '(); return false;">';
		$sort_string .= '</td></tr></form></table>';
		
		$content['Sort (table)']['content'] .= $sort_string;
		
        // Export *********************************
        if (!isset($_GET) && isset($_POST)) $_GET = $_POST;
        $query_string = "table_export.php?";
        foreach ($_GET as $k=>$v) {
            $query_string .= $k."=".$v;
            $query_string .= "&";
        }
        $query_string .= "export=".urlencode($db_titel);
        $content['Export (table)']['url'] .= BASE_REL . $activeModules['Tabellen']['directory'] . "/" . $query_string;
        $content['Export (table)']['content'] .= '<a href="'. BASE_REL . $activeModules['Tabellen']['directory'] . "/" . $query_string . '">' . __('Download') . '</a>';

		endwhile;
	}



?>
